/* 
  panoplaza template v2.0.3
*/

var PanoPlaza = PanoPlaza || {};

// for IE8
if (!Array.prototype.indexOf)
{
  Array.prototype.indexOf = function(elt /*, from*/)
  {
    var len = this.length;

    var from = Number(arguments[1]) || 0;
    from = (from < 0)
         ? Math.ceil(from)
         : Math.floor(from);
    if (from < 0)
      from += len;

    for (; from < len; from++)
    {
      if (from in this &&
          this[from] === elt)
        return from;
    }
    return -1;
  };
}

if (!Array.prototype.filter)
{
  Array.prototype.filter = function(fun /*, thisp */)
  {
    "use strict";

    if (this === void 0 || this === null)
      throw new TypeError();

    var t = Object(this);
    var len = t.length >>> 0;
    if (typeof fun !== "function")
      throw new TypeError();

    var res = [];
    var thisp = arguments[1];
    for (var i = 0; i < len; i++)
    {
      if (i in t)
      {
        var val = t[i]; // in case fun mutates this
        if (fun.call(thisp, val, i, t))
          res.push(val);
      }
    }

    return res;
  };
}

// キャッシュ対応の画像のロードイベント
$.fn.imagesLoaded = function(callback){
    var elems = this.filter('img'),
        len   = elems.length,
        blank = "data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///ywAAAAAAQABAAACAUwAOw==";

    elems.bind('load.imgloaded',function(){
        if (--len <= 0 && this.src !== blank){
            elems.unbind('load.imgloaded');
            callback.call(elems,this);
        }
    }).each(function(){
        // cached images don't fire load sometimes, so we reset src.
        if (this.complete || this.complete === undefined){
            var src = this.src;
            // webkit hack from http://groups.google.com/group/jquery-dev/browse_thread/thread/eee6ab7b2da50e1f
            // data uri bypasses webkit log warning (thx doug jones)
            this.src = blank;
            this.src = src;
        }
    });

    return this;
};
    
// VirtualShopクラス
PanoPlaza.VirtualShop = function()
{
};

PanoPlaza.VirtualShop.current = {};
PanoPlaza.VirtualShop.custom = {};

PanoPlaza.VirtualShop.onStart = function()
{
    // thickboxの画像参照パス設定
    tb_pathToProject = "../../pvs/customize/" + PanoPlaza.VirtualShop.current.template;

    if (typeof PanoPlaza.VirtualShop.custom.onStart !== 'undefined') {
        PanoPlaza.VirtualShop.custom.onStart();
    }
};

PanoPlaza.VirtualShop.routing = function()
{
    // URLの?以下を取得して連想配列に入れる
    var arg = new Object();
    var pair=location.search.substring(1).split('&');
    for(var i = 0; pair[i]; i++) {
        var kv = pair[i].split('=');
        arg[kv[0]] = kv[1];
    }

    var initPanoId = arg['panoId'];
    var inithlookat = arg['x'];
    var initvlookat = arg['y'];
    var initfov = arg['fov'];
    
    var actions = "";        
    if (initPanoId !== void 0)
    {
        var panoXml = initPanoId + ".xml";            
        actions += "breakall();"; // IE6はこの命令がないとうまくいかない
        actions += "set(onviewchange_orig, get(events.onviewchange));"; 
        actions += "set(onresize_orig, get(events.onresize));";
        actions += "set(events.onviewchange, null);"; // onviewchangeがセットされているとlookatがうまく動かないので一旦はずす 
        actions += "set(events.onresize, null);"; // onresizeがセットされているとlookatがうまく動かないので一旦はずす            
        actions += "loadpano('" + panoXml + "',null,null,NOBLEND);";
            
        if (inithlookat !== void 0 || initvlookat !== void 0) {
            if (typeof(initfov) === 'undefined') {
                if (typeof(inithlookat) === 'undefined') {
                    actions += "lookat(get(view.hlookat)," + initvlookat + ");";  
                } else if (typeof(initvlookat) === 'undefined') {
                    actions += "lookat(" + inithlookat + ",get(view.vlookat));";
                } else {
                    actions += "lookat(" + inithlookat + "," + initvlookat + ");";                    
                }
            } else {
                if (typeof(inithlookat) === 'undefined') {
                    actions += "lookat(get(view.hlookat)," + initvlookat + "," + initfov + ");";  
                } else if (typeof(initvlookat) === 'undefined') {
                    actions += "lookat(" + inithlookat + ",get(view.vlookat)," + initfov + ");"; 
                } else {
                    actions += "lookat(" + inithlookat + "," + initvlookat + "," + initfov + ");";
                }
            }
            actions += "set(events.onviewchange, get(onviewchange_orig));" +
                        "set(events.onresize, get(onresize_orig));";                
        }     
    } else {
        var panoXml = PanoPlaza.VirtualShop.current.init_panorama_id + ".xml";   
        actions += "loadpano('" + panoXml + "',null,null,NOBLEND);";
    }
    PanoPlaza.Util.execKrpanoAction(actions);    
};

PanoPlaza.VirtualShop.showLoading = function()
{
    if (typeof PanoPlaza.VirtualShop.custom.showLoading !== 'undefined') {
        PanoPlaza.VirtualShop.custom.showLoading();
    } else {
        var cx = ($(window).width() - $("#loading").width()) / 2;
        $("#loading").css("left", cx);
        $("#loading").show();        
    }
};

PanoPlaza.VirtualShop.hideLoading = function()
{
    if (typeof PanoPlaza.VirtualShop.custom.hideLoading !== 'undefined') {
        PanoPlaza.VirtualShop.custom.hideLoading();
    } else {
        $("#loading").hide();
    }    
};

// Panoramaクラス
PanoPlaza.Panorama = function()
{
};

PanoPlaza.Panorama.current = null; // 現在表示しているパノラマ
PanoPlaza.Panorama.custom = {};
PanoPlaza.Panorama.options = {};
PanoPlaza.Panorama.visited = [];

PanoPlaza.Panorama.setOptions = function(options)
{
    if (PanoPlaza.Util.isString(options)) { // krpanoから呼ばれた場合はJSON文字列
        $.extend(PanoPlaza.Panorama.options, JSON.parse(options));
    } else {    
        $.extend(PanoPlaza.Panorama.options, options);
    }
};

PanoPlaza.Panorama.getPanoramaIdFromXml = function(xmlurl)
{
    var p1 = xmlurl.lastIndexOf("/");
    var p2 = xmlurl.lastIndexOf(".xml");
    return xmlurl.substr(p1 + 1, p2 - p1 - 1);
};

PanoPlaza.Panorama.getPanoramaById = function(id)
{
    var pano = null;
    var panos = PanoPlaza.VirtualShop.current.panoramas.filter(function(item, index){
        if (item.id === id) { return true; }
    });
    if (panos.length > 0) {
        pano = panos[0];
    }
    return pano;    
};

PanoPlaza.Panorama.getPanoramaByTitle = function(title)
{
    var pano = null;
    var panos = PanoPlaza.VirtualShop.current.panoramas.filter(function(item, index){
        if (item.title === title) { return true; }
    });
    if (panos.length > 0) {
        pano = panos[0];
    }
    return pano;
};

// パノラマ遷移時のエフェクト
PanoPlaza.Panorama.applyTransitionEffect = function(id, source_id)
{
    if (typeof PanoPlaza.Panorama.custom.applyTransitionEffect !== 'undefined') {
        if (PanoPlaza.Panorama.custom.applyTransitionEffect(id, source_id) === false) {
            return;
        }
    }
    
    var panorama_hotspot = PanoPlaza.Hotspot.getHotspotById(source_id);
    if (panorama_hotspot !== null) {
        var action = "lookto(" + panorama_hotspot.ath + "," + panorama_hotspot.atv + ",50);";
        PanoPlaza.Util.execKrpanoAction(action);        
    }
};

// パノラマIdを指定してパノラマをロードする
PanoPlaza.Panorama.load = function(id, hlookat, vlookat, fov)
{   
    var actions = "";
    var passvars = PanoPlaza.Panorama.options.passvars;
            
    if (typeof PanoPlaza.Panorama.options.blendtime !== 'undefined') {
        if (PanoPlaza.Panorama.options.blendtime === null) {
            if (passvars) {
                actions += "loadpano(" + id + ".xml," + passvars + ",null,NOBLEND);"; 
            } else {
                actions += "loadpano(" + id + ".xml,null,null,NOBLEND);"; 
            }
        } else {
            if (passvars) {
                actions += "loadpano(" + id + ".xml," + passvars + ",null,BLEND(" + PanoPlaza.Panorama.options.blendtime + "));";   
            } else {
                actions += "loadpano(" + id + ".xml,null,null,BLEND(" + PanoPlaza.Panorama.options.blendtime + "));"; 
            }
        }
    } else { 
        if (passvars) {
            actions += "loadpano(" + id + ".xml," + passvars + ",null,BLEND(3));";
        } else { 
            actions += "loadpano(" + id + ".xml,null,null,BLEND(3));";
        }
    }

    if ((typeof hlookat !== 'undefined' && hlookat !== null) && (typeof vlookat !== 'undefined' && vlookat !== null)) {
        if (fov !== null && typeof fov !== 'undefined') {
            actions += "lookat(" + hlookat + "," + vlookat + "," + fov + ");"; 
        } else {
            actions += "lookat(" + hlookat + "," + vlookat + ");";          
        } 
    }  
    actions += "wait(BLEND);oninterrupt(action(lookinterrupt));action(loadingdone);";
    
    if (typeof PanoPlaza.Plugins !== 'undefined' && typeof PanoPlaza.Plugins.TraceView !== 'undefined') {
        if (PanoPlaza.Plugins.TraceView.Instance !== null) {
            PanoPlaza.Plugins.TraceView.Instance.addEvent('move', id);
        }
    }
        
    PanoPlaza.Util.execKrpanoAction(actions);
};

// パノラマ名からマッチしたパノラマをロードする
PanoPlaza.Panorama.loadByTitle = function(title, hlookat, vlookat, fov)
{
    var pano = PanoPlaza.Panorama.getPanoramaByTitle(title); 
    PanoPlaza.Panorama.load(pano.id, hlookat, vlookat, fov);
};

PanoPlaza.Panorama.onXmlLoaded = function(xmlurl)
{   
    var id = PanoPlaza.Panorama.getPanoramaIdFromXml(xmlurl);
    PanoPlaza.Panorama.current = PanoPlaza.Panorama.getPanoramaById(id);    
    
    if (typeof PanoPlaza.Panorama.custom.onXmlLoaded !== 'undefined') {
        PanoPlaza.Panorama.custom.onXmlLoaded(id);
    } 
    
    PanoPlaza.Panorama.setVisited(id);   
};

PanoPlaza.Panorama.onLoaded = function()
{   
    var id = PanoPlaza.Panorama.current.id;
    
    if (typeof PanoPlaza.Panorama.custom.onLoaded !== 'undefined') {
        PanoPlaza.Panorama.custom.onLoaded(id);
    }
};

PanoPlaza.Panorama.setVisited = function(id)
{
    if (PanoPlaza.Panorama.visited.indexOf(id) < 0) {
        PanoPlaza.Panorama.visited.push(id);
    }     
};

PanoPlaza.Panorama.isVisited = function(id)
{
    return PanoPlaza.Panorama.visited.indexOf(id) !== -1;   
};

// Itemクラス
PanoPlaza.Item = function()
{
};

PanoPlaza.Item.current = null; // 現在表示中のアイテム
PanoPlaza.Item.custom = {};
PanoPlaza.Item.options = {};
PanoPlaza.Item.template_page_cache = null;
PanoPlaza.Item.templates = {pc: "_popup.html", tablet: "_popup.html", mobile: "_popup.mobile.html"};

PanoPlaza.Item.setOptions = function(options)
{
    if (PanoPlaza.Util.isString(options)) { // krpanoから呼ばれた場合はJSON文字列
        $.extend(PanoPlaza.Item.options, JSON.parse(options));
    } else {    
        $.extend(PanoPlaza.Item.options, options);
    }
};

PanoPlaza.Item.setTemplate = function(device, template)
{
    PanoPlaza.Item.template_page_cache = null;  
    PanoPlaza.Item.templates[device] = template;    
};

PanoPlaza.Item.getItemById = function(id)
{
    var item = null;
    var items = PanoPlaza.VirtualShop.current.items.filter(function(item, index){
        if (item.id === id) { return true; }
    });
    if (items.length > 0) {
        item = items[0];
    }
    return item;     
};

PanoPlaza.Item.getItemByUID = function(uid)
{
    var item = null;
    var items = PanoPlaza.VirtualShop.current.items.filter(function(item, index){
        if (item.uid === uid) { return true; }
    });
    if (items.length > 0) {
        item = items[0];
    }
    return item;    
};

PanoPlaza.Item.getItemByCategory = function(category)
{
    var items = PanoPlaza.VirtualShop.current.items.filter(function(item, index){
        if (item.category === category) { return true; }
    });
    return items;    
};

// アイテム詳細情報をインラインポップアップウインドウで表示する
PanoPlaza.Item.showInfo = function(item, source_id)
{
    var shop = PanoPlaza.VirtualShop.current;
    var hotspot = PanoPlaza.Hotspot.getHotspotById(source_id);
    
    if (item !== null) {
        PanoPlaza.Item.current = item;
        
        if (typeof PanoPlaza.Item.options.inline_page === 'undefined') {
            PanoPlaza.Item.options.inline_page = false;
        }
        
        var viewmodel = {"item": item, "virtualshop": shop};                    
        if (item.price !== "") {
            var price_number = parseFloat(item.price);
            if (shop.currency_unit === "dollar") {
                item.price_formatted = PanoPlaza.Util.toCurrencyFormat(price_number.toFixed(2));
            } else {
                item.price_formatted = PanoPlaza.Util.toCurrencyFormat(price_number.toFixed(0)); 
            } 
        }                  
        item.directurl = shop.url + "?panoId=" + PanoPlaza.Panorama.current.id + "&amp;x=" + hotspot.ath + "&amp;y=" + hotspot.atv;
        
        switch (PanoPlaza.Util.targetDevice) {
            case "tablet+flash":
                PanoPlaza.Item.options.androidflash_hack = true;
                PanoPlaza.Item.openTemplatePage("../../pvs/customize/" + shop.template + "/" + PanoPlaza.Item.templates.tablet, viewmodel, hotspot);                 
                break;
            case "mobile+flash":
                PanoPlaza.Item.options.androidflash_hack = true;              
                PanoPlaza.Item.openTemplatePage("../../pvs/customize/" + shop.template + "/" + PanoPlaza.Item.templates.mobile, viewmodel, hotspot); 
                break;
            case "mobile+html5":
                PanoPlaza.Item.openTemplatePage("../../pvs/customize/" + shop.template + "/" + PanoPlaza.Item.templates.mobile, viewmodel, hotspot);
                break;
            case "tablet+html5":
                PanoPlaza.Item.openTemplatePage("../../pvs/customize/" + shop.template + "/" + PanoPlaza.Item.templates.tablet, viewmodel, hotspot); 
                break;
            default: // pc
                PanoPlaza.Item.openTemplatePage("../../pvs/customize/" + shop.template + "/" + PanoPlaza.Item.templates.pc, viewmodel, hotspot); 
                break;
        }
    }    
};

// アイテム詳細情報のインラインポップアップウインドウを閉じる
PanoPlaza.Item.hideInfo = function()
{
    PanoPlaza.Item.closePage();
};

PanoPlaza.Item.openTemplatePage = function(page, viewmodel, source_hotspot)
{  
    if (viewmodel === null) {
        viewmodel = {};
    }
        
    if (!PanoPlaza.Item.options.width) {
        PanoPlaza.Item.options.width = document.body.clientWidth * 3/5;
    }
    if (!PanoPlaza.Item.options.height) {
        PanoPlaza.Item.options.height = document.body.clientHeight * 2/3;
    } 
    if (typeof PanoPlaza.Item.options.androidflash_hack === 'undefined') {
        PanoPlaza.Item.options.androidflash_hack = false;  
    }
    
    if( $("#myItem").length<=0 ){
        $("body").append("<div id='myItem'></div>");
    }
    
    if (PanoPlaza.Item.template_page_cache !== null) {
        PanoPlaza.Item.openTemplatePage_onTemplateReady(viewmodel, source_hotspot);       
    } else {
        $.get(page, function(template){  
            PanoPlaza.Item.template_page_cache = template;
            PanoPlaza.Item.openTemplatePage_onTemplateReady(viewmodel, source_hotspot);                
        });         
    }   
};

PanoPlaza.Item.openTemplatePage_onTemplateReady = function(viewmodel, source_hotspot)
{
    var width = PanoPlaza.Item.options.width;
    var height = PanoPlaza.Item.options.height;
    var androidflash_hack = PanoPlaza.Item.options.androidflash_hack;
    
    if (viewmodel !== null && typeof viewmodel.item !== 'undefined') {
        PanoPlaza.Item.openPagePreAction(viewmodel.item, source_hotspot);        
    }
    
    var html = $.tmpl(PanoPlaza.Item.template_page_cache, viewmodel);
    $("#myItem").html(html);
    tb_show(null,"#TB_inline?height=" + height + "&width=" + width + "&inlineId=myItem");
             
    // Android + Flash用の処理
    if (androidflash_hack) {
        $("#pano").css("visibility", "hidden");
        $("div").css('-webkit-tap-highlight-color', 'rgba(0, 0, 0, 0)');
        $("div").css('outline', 'none');
            
        $("#TB_closeWindowButton").click(function(){
            $("#pano").css("visibility", "visible");
            PanoPlaza.Util.getKrpano().focus();
        });
            
        $("#TB_overlay").click(function(){
            $("#pano").css("visibility", "visible");
            PanoPlaza.Util.getKrpano().focus();
        });
    } else {
        // Android+html5のときクローズボタンがクリックできるようにする
        if (PanoPlaza.VirtualShop.current.map === true) {
            PanoPlaza.Util.execKrpanoAction("set(plugin[map].enabled, false);"); 
        }
        if (PanoPlaza.VirtualShop.current.welcome_message === true) {
            PanoPlaza.Util.execKrpanoAction("set(plugin[welcome].enabled, false);"); 
        } 
        $("#TB_closeWindowButton").click(function(){
            if (PanoPlaza.VirtualShop.current.map === true) {
                PanoPlaza.Util.execKrpanoAction("set(plugin[map].enabled, true);"); 
            }
            if (PanoPlaza.VirtualShop.current.welcome_message === true) {
                PanoPlaza.Util.execKrpanoAction("set(plugin[welcome].enabled, true);"); 
            }             
        });          
        $("#TB_overlay").click(function(){
            if (PanoPlaza.VirtualShop.current.map === true) {
                PanoPlaza.Util.execKrpanoAction("set(plugin[map].enabled, true);"); 
            }
            if (PanoPlaza.VirtualShop.current.welcome_message === true) {
                PanoPlaza.Util.execKrpanoAction("set(plugin[welcome].enabled, true);"); 
            }             
        });        
    } 
   
    if (viewmodel !== null && typeof viewmodel.item !== 'undefined') {
        PanoPlaza.Item.openPagePostAction(viewmodel.item, source_hotspot); 
        TB_HISTORY = {"url": "#TB_inline?height=" + height + "&width=" + width + "&inlineId=myItem", "content": html, "preFunc": {"func": PanoPlaza.Item.openPagePreAction, "args":[viewmodel.item, source_hotspot]}, "postFunc": {"func":PanoPlaza.Item.openPagePostAction, "args":[viewmodel.item, source_hotspot]}};
        tb_enableBackTrace();         
    }   
};

PanoPlaza.Item.openPagePreAction = function(item, hotspot)
{   
    if (typeof PanoPlaza.Item.custom.openPagePreAction !== 'undefined') {
        PanoPlaza.Item.custom.openPagePreAction(item, hotspot);
    }
};

PanoPlaza.Item.openPagePostAction = function(item, hotspot)
{    
    if (item.imageurl === "") {
        $('#loadingImage').css('visibility', 'hidden');
    }
    
    $('#productImage').imagesLoaded(function(){
        $('#loadingImage').css('visibility', 'hidden');
    });
    
    $('#TB_ajaxContent').css('overflow', 'hidden');
        
    if (PanoPlaza.Item.options.inline_page) {
        $("#productDetail").addClass("TB_HISTORY");
    }
   
    $("#productDetail").click(function(){
        PanoPlaza.Util.eventLog('itemDetail', item.title, item.id); // 詳細のクリック以外のイベントxmlの中でログをとる
 
        if (PanoPlaza.VirtualShop.current.log) {
            AddLog('clickItemDetail', item.id, hotspot.id);
        }
        
        if (typeof PanoPlaza.Plugins !== 'undefined' && typeof PanoPlaza.Plugins.TraceView !== 'undefined') {
            if (PanoPlaza.Plugins.TraceView.Instance !== null) {
                PanoPlaza.Plugins.TraceView.Instance.addEvent('open_url', item.linkurl);
            }
        }
        
        PanoPlaza.Util.openUrl(item.linkurl, PanoPlaza.Item.options);
        return false;
    });
    $("#productTwitter").click(function(){
        if (PanoPlaza.VirtualShop.current.log) {
            AddLog('clickItemTweet', item.id, hotspot.id);
        }
        PanoPlaza.Item.onTweet();
        return false;
    });
    
    if (typeof PanoPlaza.Item.custom.openPagePostAction !== 'undefined') {
        PanoPlaza.Item.custom.openPagePostAction(item, hotspot);
    }     
};

PanoPlaza.Item.closePage = function()
{
    tb_remove();
   
    // Android + Flash用の処理
    $("#pano").css("visibility", "visible"); 
    
    // Traceview
    if (typeof PanoPlaza.Plugins !== 'undefined' && typeof PanoPlaza.Plugins.TraceView !== 'undefined')
    {
        if (PanoPlaza.Plugins.TraceView.Instance !== null) {
            PanoPlaza.Plugins.TraceView.Instance.addEvent("close_item");
        }
    }       
};

PanoPlaza.Item.onTweet = function()
{
    var login  = 'kadinche';
    var apiKey = 'R_d20834c58d0bba3fa0c1fbfb95d58cd9';
    bitly = 'http://api.bit.ly/shorten' 
        + '?version=2.0.1&format=json&callback=PanoPlaza.Item.onTweetCallback'
        + '&login=' + login
        + '&apiKey=' + apiKey + '&longUrl=';
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = bitly + encodeURIComponent(PanoPlaza.Item.current.directurl);
    document.body.appendChild(script);    
};

PanoPlaza.Item.onTweetCallback = function(bitlyResult)
{
    var shop = PanoPlaza.VirtualShop.current;
    var item = PanoPlaza.Item.current;
    
    var status = encodeURIComponent(item.title+" "+bitlyResult.results[item.directurl]['shortUrl']+" "+shop.hashtag); 
    var url = "https://twitter.com/intent/tweet?text=" + status;
 
    // open a link on self window 
    // location.href = url;    
       
    // open a link on new window 
    PanoPlaza.Util.openUrl(url);   
};

// Hotspotクラス
PanoPlaza.Hotspot = function()
{
};

PanoPlaza.Hotspot.custom = {};
PanoPlaza.Hotspot.options = {};
PanoPlaza.Hotspot.visited = [];
PanoPlaza.Hotspot.effects = {};

PanoPlaza.Hotspot.setOptions = function(options)
{
    if (PanoPlaza.Util.isString(options)) { // krpanoから呼ばれた場合はJSON文字列
        $.extend(PanoPlaza.Hotspot.options, JSON.parse(options));
    } else {    
        $.extend(PanoPlaza.Hotspot.options, options);
    }
};

PanoPlaza.Hotspot.getHotspotById = function(hotspot_id)
{
    var hotspot = null;
    var hotspots = PanoPlaza.VirtualShop.current.hotspots.filter(function(item, index){
        if (item.id === hotspot_id) { return true; }
    });
    if (hotspots.length > 0) {
        hotspot = hotspots[0];
    }
    
    return hotspot;    
};

PanoPlaza.Hotspot.getHotspotByAssociatedId = function(associated_id)
{
    var hotspot = null;
    var hotspots = PanoPlaza.VirtualShop.current.hotspots.filter(function(item, index){
        if (item.associated_id === associated_id) { return true; }
    });
    if (hotspots.length > 0) {
        hotspot = hotspots[0];
    }
    
    return hotspot;    
};

PanoPlaza.Hotspot.getAssociatedPanorama = function(hotspot_id)
{
    var pano = null;
    var hotspot = null;
    var hotspots = PanoPlaza.VirtualShop.current.hotspots.filter(function(item, index){
        if (item.id === hotspot_id && item.type === "panorama") { return true; }
    });
    if (hotspots.length > 0) {
        hotspot = hotspots[0];
    }
    
    if (hotspot !== null) {
        pano = PanoPlaza.Panorama.getPanoramaById(hotspot.associated_id);
    }
    return pano;    
};

PanoPlaza.Hotspot.getAssociatedItem = function(hotspot_id)
{
    var item = null;
    var hotspot = null;
    var hotspots = PanoPlaza.VirtualShop.current.hotspots.filter(function(item, index){
        if (item.id === hotspot_id && item.type === "item") { return true; }
    });
    if (hotspots.length > 0) {
        hotspot = hotspots[0];
    }
    
    if (hotspot !== null) {
        item = PanoPlaza.Item.getItemById(hotspot.associated_id);
    }
    return item;    
};

// ホットスポットに属性をセットする
PanoPlaza.Hotspot.setAttribute = function(hotspot_id, name, value)
{
    var actions = "set(hotspot[hotspot_" + hotspot_id + "]." + name + "," + value + ");";
    PanoPlaza.Util.execKrpanoAction(actions);
};

// ホットスポットがロードされたときに行う処理
PanoPlaza.Hotspot.onLoaded = function(hotspot_id, type)
{
    if (typeof PanoPlaza.Hotspot.custom.onLoaded !== 'undefined') {
        PanoPlaza.Hotspot.custom.onLoaded(hotspot_id, type);
    }
};

// ホットスポットがクリックされたときに行う処理
PanoPlaza.Hotspot.onClicked = function(hotspot_id, type)
{   
    PanoPlaza.Hotspot.setVisited(hotspot_id);
    
    if (typeof PanoPlaza.Hotspot.custom.onClicked !== 'undefined') {
        if (PanoPlaza.Hotspot.custom.onClicked(hotspot_id, type) === false) {
            return;
        };
    }    
    
    if (typeof PanoPlaza.Hotspot.effects.onclick === 'undefined') {
        PanoPlaza.Hotspot.effects.onclick = {};
        if (typeof PanoPlaza.Hotspot.effects.onclick.actionName === 'undefined') {
            PanoPlaza.Hotspot.effects.onclick.actionName = "effect_hotspot_onclick"; // エフェクトのアクション名
        }        
        if (typeof PanoPlaza.Hotspot.effects.onclick.duration === 'undefined') {
            PanoPlaza.Hotspot.effects.onclick.speed = 0.2; // エフェクトの速さ（sec）
        }        
        if (typeof PanoPlaza.Hotspot.effects.onclick.delta === 'undefined') {
            PanoPlaza.Hotspot.effects.onclick.intensity = 0.5; // エフェクトの強度
        }
        if (typeof PanoPlaza.Hotspot.effects.onclick.delay === 'undefined') {
            PanoPlaza.Hotspot.effects.onclick.wait = 0.6; // エフェクト後のアクション開始までの時間（sec）
        }
    };

    var hotspot_name = "hotspot_" + hotspot_id;
    var actionName = PanoPlaza.Hotspot.effects.onclick.actionName; 
    var wait = PanoPlaza.Hotspot.effects.onclick.wait;

    if (typeof actionName !== 'undefined' && actionName !== null) {
        var effect_command = actionName + "(" + hotspot_name;
// IE8ではObject.keysは非サポート        
//        var keys = Object.keys(PanoPlaza.Hotspot.effects.onclick).sort(); // keyをアルファベット順にソートする
        var keys = $.map(PanoPlaza.Hotspot.effects.onclick, function(value, key) {
            return key;
        }).sort();
        for (var i = 0, len = keys.length; i < len; i++) {
            if (keys[i] !== "actionName" && keys[i] !== "wait") { // actionNameとwait以外のパラメータを渡す
                effect_command += "," + PanoPlaza.Hotspot.effects.onclick[keys[i]];
            }
        }
        effect_command += ");";
        PanoPlaza.Util.execKrpanoAction(effect_command);         
    } else {
        wait = 0;
    }

    setTimeout(function(){
        if (type === "item") {
            var item = PanoPlaza.Hotspot.getAssociatedItem(hotspot_id);
            PanoPlaza.Item.showInfo(item, hotspot_id); 
        } else if (type === "panorama") {
            PanoPlaza.Util.execKrpanoAction("action_" + hotspot_id + "();");      
        }        
    }, wait * 1000);
};

PanoPlaza.Hotspot.setVisited = function(hotspot_id)
{
    if (PanoPlaza.Hotspot.visited.indexOf(hotspot_id) < 0) {
        PanoPlaza.Hotspot.visited.push(hotspot_id);
    }   
};

// ホットスポットが一回以上クリックされているか
PanoPlaza.Hotspot.isVisited = function(hotspot_id)
{
    return PanoPlaza.Hotspot.visited.indexOf(hotspot_id) !== -1; 
};

PanoPlaza.Hotspot.remoteClick = function(x, y, th)
{
    var screenX = x * $(window).width();
    var screenY = y * $(window).height();
    
    var action = "set(screenX," + screenX + ");set(screenY," + screenY + ");"
                + "screentosphere(screenX, screenY, toh, tov);"
                + "js(PanoPlaza.Hotspot.remoteClickCallback(get(toh), get(tov)," + th + "));";
        
    PanoPlaza.Util.execKrpanoAction(action);
};

PanoPlaza.Hotspot.remoteClickCallback = function(h, v, th)
{
    if (PanoPlaza.Util.isString(h)) { // krpanoから呼ばれた場合は数値ではなく文字列
        h = parseFloat(h);
    }
    if (PanoPlaza.Util.isString(v)) { // krpanoから呼ばれた場合は数値ではなく文字列
        v = parseFloat(v);
    }
    if (PanoPlaza.Util.isString(th)) { // krpanoから呼ばれた場合は数値ではなく文字列
        th = parseFloat(th);
    }    

    var hotspot_selected = null;
    var dmin = -1;
    
    PanoPlaza.VirtualShop.current.hotspots.filter(function(item, index){
        if (item.panorama_id === PanoPlaza.Panorama.current.id) {
            var d = Math.abs((item.ath - h) + (item.atv - v) / 2);
            if (d <= th && (dmin < 0 || d < dmin)) {
                hotspot_selected = item;
                dmin = d;
                return true; 
            }
        }
    });
    
    if (hotspot_selected !== null) {
        PanoPlaza.Hotspot.onClicked(hotspot_selected.id, hotspot_selected.type);
    }
};


// FloorMapクラス
PanoPlaza.FloorMap = function()
{
};

PanoPlaza.FloorMap.custom = {};

PanoPlaza.FloorMap.open = function()
{
    if (PanoPlaza.VirtualShop.current.map === true) {
        PanoPlaza.Util.execKrpanoAction("map_open();"); 
    }
};

PanoPlaza.FloorMap.close = function()
{
    if (PanoPlaza.VirtualShop.current.map === true) {
        PanoPlaza.Util.execKrpanoAction("map_close();"); 
    }
};

PanoPlaza.FloorMap.onOpened = function()
{
    if (typeof PanoPlaza.FloorMap.custom.onOpened !== 'undefined') {
        PanoPlaza.FloorMap.custom.onOpened();
    }
};

PanoPlaza.FloorMap.onClosed = function()
{
    if (typeof PanoPlaza.FloorMap.custom.onClosed !== 'undefined') {
        PanoPlaza.FloorMap.custom.onClosed();
    }
};

// FloorMapLinkクラス
PanoPlaza.FloorMapLink = function()
{
};

PanoPlaza.FloorMapLink.custom = {};
PanoPlaza.FloorMapLink.options = {};
PanoPlaza.FloorMapLink.visited = [];
PanoPlaza.FloorMapLink.effects = {};

PanoPlaza.FloorMapLink.setOptions = function(options)
{
    if (PanoPlaza.Util.isString(options)) { // krpanoから呼ばれた場合はJSON文字列
        $.extend(PanoPlaza.FloorMapLink.options, JSON.parse(options));
    } else {    
        $.extend(PanoPlaza.FloorMapLink.options, options);
    }
};

PanoPlaza.FloorMapLink.getAssociatedPanorama = function(maplink_id)
{
    var pano = null;
    var maplink = null;
    var maplinks = PanoPlaza.VirtualShop.current.maplinks.filter(function(item, index){
        if (item.id === maplink_id) { return true; }
    });
    if (maplinks.length > 0) {
        maplink = maplinks[0];
    }
    
    if (maplink !== null) {
        pano = PanoPlaza.Panorama.getPanoramaById(maplink.associated_id);
    }
    return pano;    
};

// フロアマップリンクに属性をセットする
PanoPlaza.FloorMapLink.setAttribute = function(maplink_id, name, value)
{
    var actions = "set(plugin[floor_" + maplink_id + "]." + name + "," + value + ");";
    PanoPlaza.Util.execKrpanoAction(actions);
};

// フロアマップリンクがロードされたときに行う処理
PanoPlaza.FloorMapLink.onLoaded = function(maplink_id, is_active)
{
    if (PanoPlaza.Util.isString(is_active)) { // krpanoから呼ばれた場合はJSON文字列
        is_active = JSON.parse(is_active);
    }
    
    if (typeof PanoPlaza.FloorMapLink.custom.onLoaded !== 'undefined') {
        PanoPlaza.FloorMapLink.custom.onLoaded(maplink_id, is_active);
    }
};

// フロアマップリンクがクリックされたときに行う処理
PanoPlaza.FloorMapLink.onClicked = function(maplink_id, is_active)
{   
    PanoPlaza.FloorMapLink.setVisited(maplink_id);
    
    if (PanoPlaza.Util.isString(is_active)) { // krpanoから呼ばれた場合はJSON文字列
        is_active = JSON.parse(is_active);
    }

    if (typeof PanoPlaza.FloorMapLink.custom.onClicked !== 'undefined') {
        if (PanoPlaza.FloorMapLink.custom.onClicked(maplink_id, is_active) === false) {
            return;
        }
    }    

    if (typeof PanoPlaza.FloorMapLink.effects.onclick === 'undefined') {
        PanoPlaza.FloorMapLink.effects.onclick = {};
        if (typeof PanoPlaza.FloorMapLink.effects.onclick.actionName === 'undefined') {
            PanoPlaza.FloorMapLink.effects.onclick.actionName = "effect_plugin_onclick"; // エフェクトのアクション名
        }        
        if (typeof PanoPlaza.FloorMapLink.effects.onclick.duration === 'undefined') {
            PanoPlaza.FloorMapLink.effects.onclick.speed = 0.2; // エフェクトの速さ（sec）
        }        
        if (typeof PanoPlaza.FloorMapLink.effects.onclick.delta === 'undefined') {
            PanoPlaza.FloorMapLink.effects.onclick.intensity = 0.5; // エフェクトの強度
        }
        if (typeof PanoPlaza.FloorMapLink.effects.onclick.delay === 'undefined') {
            PanoPlaza.FloorMapLink.effects.onclick.wait = 0.6; // エフェクト後のアクション開始までの時間（sec）
        }
    };

    var maplink_name = "floor_" + maplink_id;
    var actionName = PanoPlaza.FloorMapLink.effects.onclick.actionName; 
    var wait = PanoPlaza.FloorMapLink.effects.onclick.wait;

    if (typeof actionName !== 'undefined' && actionName !== null) {
        var effect_command = actionName + "(" + maplink_name;
// IE8ではObject.keysは非サポート        
//        var keys = Object.keys(PanoPlaza.FloorMapLink.effects.onclick).sort(); // keyをアルファベット順にソートする
        var keys = $.map(PanoPlaza.FloorMapLink.effects.onclick, function(value, key) {
            return key;
        }).sort();        
        for (var i = 0, len = keys.length; i < len; i++) {
            if (keys[i] !== "actionName" && keys[i] !== "wait") { // actionNameとwait以外のパラメータを渡す
                effect_command += "," + PanoPlaza.FloorMapLink.effects.onclick[keys[i]];
            }
        }
        effect_command += ");";
    } else {
        wait = 0;
    }
    
    PanoPlaza.Util.execKrpanoAction(effect_command); 
    setTimeout(function(){
        var panorama = PanoPlaza.FloorMapLink.getAssociatedPanorama(maplink_id);
        PanoPlaza.Panorama.load(panorama.id);    
    }, wait * 1000);
};

PanoPlaza.FloorMapLink.setVisited = function(maplink_id)
{
    if (PanoPlaza.FloorMapLink.visited.indexOf(maplink_id) < 0) {
        PanoPlaza.FloorMapLink.visited.push(maplink_id);
    }   
};

// フロアマップリンクが一回以上クリックされているか
PanoPlaza.FloorMapLink.isVisited = function(maplink_id)
{
    return PanoPlaza.FloorMapLink.visited.indexOf(maplink_id) !== -1; 
};

// Utilityクラス
PanoPlaza.Util = function()
{
    
};

PanoPlaza.Util.krpano = [];
PanoPlaza.Util.targetDevice = "default";
PanoPlaza.Util.options = {};

PanoPlaza.Util.isString = function(obj) {
    var clas = Object.prototype.toString.call(obj).slice(8, -1);
    return obj !== undefined && obj !== null && clas === 'String';
};

PanoPlaza.Util.setOptions = function(options)
{
    if (PanoPlaza.Util.isString(options)) { // krpanoから呼ばれた場合はJSON文字列
        $.extend(PanoPlaza.Util.options, JSON.parse(options));
    } else {    
        $.extend(PanoPlaza.Util.options, options);
    }
};

PanoPlaza.Util.setKrpano = function(krpano)
{
    PanoPlaza.Util.krpano.push(krpano); 
};

PanoPlaza.Util.getKrpano = function(index)
{
    if (PanoPlaza.Util.krpano.length === 0) {
        var krpano = document.getElementById("krpanoSWFObject");
        if (krpano !== null) {
            PanoPlaza.Util.setKrpano(krpano);
        }
    }
    
    if (!index) {
        index = 0;
    }
    
    return PanoPlaza.Util.krpano[index];      
};

PanoPlaza.Util.execKrpanoAction = function(actions)
{
    for (var i = 0; i < PanoPlaza.Util.krpano.length; i++) {
        var krpano = PanoPlaza.Util.getKrpano(i);   
        if (typeof PanoPlaza.Util.options.targetKrpano === 'undefined' || PanoPlaza.Util.options.targetKrpano.indexOf(krpano.id) >= 0) { 
            if (krpano !== null && actions !== null && actions !== "") { 
                krpano.call(actions);
            }   
        }
    }
};

PanoPlaza.Util.setTargetDevice = function(device)
{
    PanoPlaza.Util.targetDevice = device;
};

PanoPlaza.Util.openUrl = function(url, options) 
{    
    if (PanoPlaza.Util.isString(options)) { // krpanoから呼ばれた場合はJSON文字列
        try {
            options = JSON.parse(options);
        }
        catch(e) {
//            console.log(e);
        }
    }
    
    if (typeof options !== 'undefined' && typeof options.inline_page !== 'undefined' && options.inline_page === true) {
        $("#TB_window").empty();      
        var width = document.body.clientWidth * 3/5;
        var height = document.body.clientHeight * 2/3;
        if (typeof options.width !== 'undefined') {
            width = options.width;
        }
        if (typeof options.height !== 'undefined') {
            height = options.height;
        }        
        url = url + "?TB_iframe=true&width=" + width + "&height=" + height;
        tb_show("", url);
        
        // iOSでiframe内にコンテンツが収まらない対策
        if (PanoPlaza.Util.is_iOS() === true) {
            $("#TB_iframeContent").css("overflow", "scroll");
            $("iframe#TB_iframeContent").wrap("<div id='TB_iOS'>");
            $("#TB_iOS").css('width', $("#TB_iframeContent").width() + 'px');
            $("#TB_iOS").css('height', $("#TB_iframeContent").height() + 'px');   
            $("#TB_iOS").css("overflow", "scroll");
            $("#TB_iOS").css("-webkit-overflow-scrolling", "touch");
        }
     
        if (typeof options.showloading !== 'undefined' && options.showloading === false) {
            $("#TB_load").hide();
        }
        
        // X-Frame-Optionsによりアクセス許可されていない場合はalertを出す
        PanoPlaza.Util.checkXFrameOptions(url); 
    
        return;        
    }

    var agent = navigator.userAgent;
    if (agent.search(/iPad/) !== -1 || agent.search(/Android/) !== -1) {
        var a = document.createElement('a');
        a.setAttribute("href", url);
        a.setAttribute("target", "_blank");
        var dispatch = document.createEvent("HTMLEvents")
        dispatch.initEvent("click", true, true);
        a.dispatchEvent(dispatch);
        try {
            document.removeChild(a);
        } catch(e) {
        }
    } else {
        var newWindow = window.open(url, "_blank");
        if(!newWindow || newWindow.closed || typeof newWindow.closed === 'undefined') {
            var lang = PanoPlaza.VirtualShop.current.lang;
            if(lang === "ja") {
                alert("ポップアップがブロックされました\nブラウザの設定をご確認ください");
            } else {
                alert("Popup was blocked.\nPlease check your browser's settings");
            }
        }       
    }
};  

// thickboxを使わずにhtmlページのウインドウを開く
PanoPlaza.Util.openInlineFrame = function(url, data, options, onloadFunc) 
{    
    var width = document.body.clientWidth * 3/5;
    var height = document.body.clientHeight * 2/3;
    var overflow_x = "hidden";
    var overflow_y = "hidden";
    var bgcolor = "#ffffff";
    var androidflash_hack = false;
    var crossdomain = false;
    var fitTo = null;
    var fitWidth = false;
    var fitHeight = false;
    var addCloseButton = true;
    
    if (options && typeof options.width !== 'undefined') {
        width = options.width;
    }
    if (options && typeof options.height !== 'undefined') {
        height = options.height;
    } 
    if (options && options.overflow_x) {
        overflow_x = options.overflow_x;
    } 
    if (options && options.overflow_y) {
        overflow_y = options.overflow_y;
    }
    if (options && options.bgcolor) {
        bgcolor = options.bgcolor;
    }    
    if (options && options.crossdomain) {
        crossdomain = options.crossdomain;
    }     
    if (options && options.fitWidth) {
        fitWidth = options.fitWidth;
    } 
    if (options && options.fitHeight) {
        fitHeight = options.fitHeight;
    }     
    if (options && options.fitTo) {
        fitTo = options.fitTo;
    } 
    if (options && typeof options.addCloseButton !== 'undefined') {
        addCloseButton = options.addCloseButton;
    } 
    
    if (["mobile+flash", "tablet+flash"].indexOf(PanoPlaza.Util.targetDevice) >= 0) {
        androidflash_hack = true;  
    }
    
    if( $("#myDiv").length<=0 ){
        $("body").append("<div id='myDiv'></div>");
        $("body").append("<div id='myDiv_overlay' style='position:fixed;z-index:2100;top:0px;left:0px;width:100%;height:100%;'></div>");
    }
 
    $("#myDiv").empty();
    $("#myDiv").prepend("<div id='myDivInner'></div>");
    $("#myDiv").css("position", "absolute");   
    $("#myDiv").css("background-color", bgcolor);
    $("#myDiv").css("color", "#000000");
    $("#myDiv").css("z-index", 999999999);    
    $("#myDivInner").css("overflow-x", overflow_x); 
    $("#myDivInner").css("overflow-y", overflow_y);
    $("#myDivInner").css("width", width + "px");
    $("#myDivInner").css("height", height + "px");

    var left = ($(window).width() - width) / 2;
    var top = ($(window).height() - height) / 2;
    
    $("#myDiv").css("left", left + "px");
    $("#myDiv").css("top", top + "px");

    if (crossdomain === false) {
        $.get(url, function(template){             
            var html = $.tmpl(template, data);
            $("#myDivInner").html(html);
            
            // 閉じるボタンを追加
            if (addCloseButton === true) {
                $("#myDiv").prepend("<a href='javascript://' id='myDiv_closeWindowButton' style='position:absolute;right:5px;top:5px;display:none;'><img src='../../pvs/customize/" + PanoPlaza.VirtualShop.current.template + "/image/item_closeButton.png' /></a>");
                $("#myDiv_closeWindowButton").click(function(){
                    PanoPlaza.Util.closeInlineFrame();
                    return false;
                });
                 
                // fitしたい場合もあるのでdelayをつけて表示する
                setTimeout(function(){
                   $("#myDiv_closeWindowButton").show(); 
                }, 500);
            }
            
            // ウインドウ幅をコンテンツの幅に合わせる (align=center以外では位置の再調整が必要)          
            var lastScrollHeight = 0;            
            if (fitTo !== null && fitWidth === true) {
                var closeButtonPosition = parseInt($("#myDiv_closeWindowButton").css("right")); // closeボタンを付加しない場合でもエラーにならない
                (function adjustingWidth(){
                    setTimeout(function(){
                        var has_scrollBar = $("#myDivInner").get(0).scrollHeight > $("#myDivInner").height();  
                        var scrollBar_offset = PanoPlaza.Util.isMobile() || PanoPlaza.Util.isTablet() ? 0 : 15;                      
                        if (has_scrollBar) {
                            $("#myDiv_closeWindowButton").css("right", closeButtonPosition + scrollBar_offset + "px"); // スクロールバーの分だけオフセットをつける
                            $("#myDivInner").css("width", $(fitTo).width() + scrollBar_offset + "px"); // スクロールバーの分だけ大きくする。サイズはmyDivInnerで設定
                        } else {
                            $("#myDivInner").css("width", $(fitTo).width() + "px"); // サイズはmyDivInnerで設定 
                        }                         
                        if (!lastScrollHeight || (lastScrollHeight < $("#myDivInner").get(0).scrollHeight)) { // scrollHeightの値を見てポーリングをストップ
                            lastScrollHeight = $("#myDivInner").get(0).scrollHeight;
                            adjustingWidth();
                        }
                    }, 20);
                })();
                $("#myDiv").css("left", ($(window).width() - $(fitTo).width()) / 2 + "px"); // 位置はmyDivで設定          
            }

            // ウインドウ高さをコンテンツの高さに合わせる 
            if (fitTo !== null && fitHeight === true) { 
                (function adjustingHeight(){
                    setTimeout(function(){
                        var has_scrollBar = $("#myDivInner").get(0).scrollHeight > $("#myDivInner").height();  
                        if (has_scrollBar === false && $("#myDivInner").height() > $(fitTo).height()) {
                            $("#myDivInner").css("height", $(fitTo).height() + "px"); // サイズはmyDivInnerで設定 
                            $("#myDiv").css("top", ($(window).height() - $(fitTo).height()) / 2 + "px");  
                        }   
                        if (!lastScrollHeight || (lastScrollHeight < $("#myDivInner").get(0).scrollHeight)) { // scrollHeightの値を見てポーリングをストップ
                            lastScrollHeight = $("#myDivInner").get(0).scrollHeight;
                            adjustingHeight();
                        }
                    }, 20);
                })();             
            }
            
            // 画面回転やリサイズに対応
            $(window).on("orientationchange.mydiv resize.mydiv", function(){ // 名前空間を利用してイベントをグループ化する
                $("#myDiv").css("left", ($(window).width() - $("#myDivInner").width()) / 2 + "px"); 
                $("#myDiv").css("top", ($(window).height() - $("#myDivInner").height()) / 2 + "px"); 
            });    
                
            // Android3.0未満の端末でもスクロールできるようにする
            if (androidflash_hack && (overflow_y === "scroll" || overflow_y === "auto")) {
                var box = $('#myDivInner')[0];
                var touchStartPositionY;
                var touchMovePositionY;
                var moveFarY;
                var startScrollY;
                var moveScrollY;

                box.addEventListener("touchstart",touchHandler,false);
                box.addEventListener("touchmove",touchHandler,false);

                function touchHandler(e){
                    var touch = e.touches[0];
                    if(e.type === "touchstart"){
                        touchStartPositionY = touch.pageY;
			//タッチ前スクロールをとる
			startScrollY = $('#myDivInner').scrollTop();
                    }   
		
                    if(e.type === "touchmove"){
			e.preventDefault();
			//現在の座標を取得
			touchMovePositionY = touch.pageY;
			//差をとる
			moveFarY = touchStartPositionY - touchMovePositionY;
			
			//スクロールを動かす
			moveScrollY = startScrollY +moveFarY;
			$('#myDivInner').scrollTop(moveScrollY);
                    }
                }                  
            }
            
            if (onloadFunc) {
                onloadFunc();  
            }

            $("#myDiv").show();  
            
            // 閉じるボタンをつけなかったときに閉じれるようにしておく
            if (addCloseButton === false) {
                $("#myDiv_overlay").click(function(){
                    PanoPlaza.Util.closeInlineFrame();
                });
            }

            // Androidのときクローズボタンがクリックできるようにする
            if (PanoPlaza.VirtualShop.current.map === true) {
                PanoPlaza.Util.execKrpanoAction("set(plugin[map].enabled, false);"); 
            }
            if (PanoPlaza.VirtualShop.current.welcome_message === true) {
                PanoPlaza.Util.execKrpanoAction("set(plugin[welcome].enabled, false);"); 
            }              
        });       
    } else {
        $("#myDiv").html("<iframe id='myDiv_iframe' src='" + url + "' scrolling='yes' frameborder='0' />");   
        $("#myDiv_iframe").attr("width", width);
        $("#myDiv_iframe").attr("height", height);
        
        // 閉じるボタンを追加
        if (addCloseButton) {
            $("#myDiv").prepend("<a href='javascript://' id='myDiv_closeWindowButton' style='position:absolute;right:5px;top:5px;'><img src='../../pvs/customize/" + PanoPlaza.VirtualShop.current.template + "/image/item_closeButton.png' /></a>");
            $("#myDiv_closeWindowButton").click(function(){
                PanoPlaza.Util.closeInlineFrame();
                return false;
            });    
        }
    
        // 画面回転やリサイズに対応
        $(window).on("orientationchange.mydiv resize.mydiv", function(){ // 名前空間を利用してイベントをグループ化する
            $("#myDiv").css("left", ($(window).width() - $("#myDiv_iframe").width()) / 2 + "px"); 
            $("#myDiv").css("top", ($(window).height() - $("#myDiv_iframe").height()) / 2 + "px"); 
        });    
            
        if (onloadFunc) {
            onloadFunc();
        }       
      
        $("#myDiv").show(); 
        
        // 閉じるボタンをつけなかったときに閉じれるようにしておく
        if (addCloseButton === false) {
            $("#myDiv_overlay").click(function(){
                PanoPlaza.Util.closeInlineFrame();
            });
        }
       
        // Androidのときクローズボタンがクリックできるようにする
        if (PanoPlaza.VirtualShop.current.map === true) {
            PanoPlaza.Util.execKrpanoAction("set(plugin[map].enabled, false);"); 
        }
        if (PanoPlaza.VirtualShop.current.welcome_message === true) {
            PanoPlaza.Util.execKrpanoAction("set(plugin[welcome].enabled, false);"); 
        }
        
        // X-Frame-Optionsによりアクセス許可されていない場合はalertを出す
        PanoPlaza.Util.checkXFrameOptions(url);         
    }
  
    // Android + Flash用の処理
    if (androidflash_hack) {
        $("#pano").css("visibility", "hidden");   
    }       
       
};

PanoPlaza.Util.closeInlineFrame = function() 
{   
    $("#myDiv").remove();
    $("#myDiv_overlay").remove();
 
    // イベントの解除
    $(window).off(".mydiv");
 
    // Android用の処理
    if (PanoPlaza.VirtualShop.current.map === true) {
        PanoPlaza.Util.execKrpanoAction("set(plugin[map].enabled, true);"); 
    }
    if (PanoPlaza.VirtualShop.current.welcome_message === true) {
        PanoPlaza.Util.execKrpanoAction("set(plugin[welcome].enabled, true);"); 
    }   
            
    // Android + Flash用の処理
    $("#pano").css("visibility", "visible");          
};

PanoPlaza.Util.checkHttpHeader = function(url, key, onSuccess) 
{ 
//    var api_url = PanoPlaza.VirtualShop.current.api_base_url + "CheckHttpHeader.aspx";
    var api_url = "http://kadinchetest.cloudapp.net/Public/API/CheckHttpHeader.aspx";    
    var param = {url : url};
    if (key) {
        param['key'] = key;
    }
    
    $.ajax({
        type: 'POST',
        data: param,
        dataType: 'json',
        url: api_url,
        success: function(data) {
            onSuccess(data);
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {         
        }
    });
           
};
       
PanoPlaza.Util.checkXFrameOptions = function(url) 
{ 
    PanoPlaza.Util.checkHttpHeader(url, "X-Frame-Options", function(data) {
        if (data["x-frame-options"]) {
            if (["SAMEORIGIN", "DENY"].indexOf(data["x-frame-options"]) >= 0) {
                switch(PanoPlaza.VirtualShop.current.lang) {
                    case "ja":
                        alert("このWebページはインラインウインドウでの表示が許可されていません");
                        break;
                    default:
                        alert("This web page is not allowed to view in an inline window."); 
                }            
            }
        }        
    });      
};

PanoPlaza.Util.useHtml5 = function()
{
    var arg = new Object();
    var pair=location.search.substring(1).split('&');
    for(var i = 0; pair[i]; i++) {
        var kv = pair[i].split('=');
        arg[kv[0]] = kv[1];
    }
    return arg['html5'] === "true";
};

PanoPlaza.Util.isAndroid = function()
{
    return navigator.userAgent.indexOf('Android') >= 0;
};

PanoPlaza.Util.is_iOS = function()
{
    var ua = navigator.userAgent;
    return ua.indexOf('iPhone') >= 0 || ua.indexOf('iPad') >= 0 || ua.indexOf('iPod') >= 0;
};

PanoPlaza.Util.isFlashInstalled = function()
{
    if(navigator.plugins["Shockwave Flash"]){ 
        return true;
    }try{
        new ActiveXObject("ShockwaveFlash.ShockwaveFlash");
        return true;
    }catch(a){
        return false;
    }    
};

PanoPlaza.Util.isTablet = function()
{
    return ["tablet+flash", "tablet+html5"].indexOf(PanoPlaza.Util.targetDevice) >= 0;
};

PanoPlaza.Util.isMobile = function()
{
    return ["mobile+flash", "mobile+html5"].indexOf(PanoPlaza.Util.targetDevice) >= 0;    
};

PanoPlaza.Util.getFlashVersion = function()
{
    // ie
    try {
        try {
            // avoid fp6 minor version lookup issues
            // see: http://blog.deconcept.com/2006/01/11/getvariable-setvariable-crash-internet-explorer-flash-6/
            var axo = new ActiveXObject('ShockwaveFlash.ShockwaveFlash.6');
            try { axo.AllowScriptAccess = 'always'; }
            catch(e) { return '6,0,0'; }
        } catch(e) {}
        return new ActiveXObject('ShockwaveFlash.ShockwaveFlash').GetVariable('$version').replace(/\D+/g, ',').match(/^,?(.+),?$/)[1];
    // other browsers
    } catch(e) {
        try {
            if(navigator.mimeTypes["application/x-shockwave-flash"].enabledPlugin){
                return (navigator.plugins["Shockwave Flash 2.0"] || navigator.plugins["Shockwave Flash"]).description.replace(/\D+/g, ",").match(/^,?(.+),?$/)[1];
            }
        } catch(e) {}
    }
    return '0,0,0';    
};

PanoPlaza.Util.getFlashMajorVersion = function()
{
    return PanoPlaza.Util.getFlashVersion().split(',').shift();
};

PanoPlaza.Util.getAndroidVersion = function()
{
    var ua = ua || navigator.userAgent; 
    var match = ua.match(/Android\s([0-9\.]*)/);
    return match ? match[1] : "0";   
};

PanoPlaza.Util.getAndroidMajorVersion = function()
{
    return parseInt(PanoPlaza.Util.getAndroidVersion());
};

PanoPlaza.Util.setViewport = function(density, scale)
{
    var meta = document.createElement('meta');
    meta.setAttribute('name', 'viewport');
    meta.setAttribute('content', 'target-densitydpi=' + density + ', width=device-width, initial-scale=' + scale + ', user-scalable=false');
    document.getElementsByTagName('head')[0].appendChild(meta);    
};

PanoPlaza.Util.setViewportScale = function(scale)
{
    var meta = document.createElement('meta');
    meta.setAttribute('name', 'viewport');
    meta.setAttribute('content', 'target-densitydpi=device-dpi, width=device-width, initial-scale=' + scale + ', user-scalable=false');
    document.getElementsByTagName('head')[0].appendChild(meta);    
};

// GoogleAnalyticsのイベントログ
PanoPlaza.Util.eventLog = function(action, label, id)
{  
    var actions = "ga_event(" + label + " [" + action + "]," + id + ");";       
    PanoPlaza.Util.execKrpanoAction(actions); 
};

PanoPlaza.Util.toCurrencyFormat = function(price)
{
    var str= price;
    var num = new String(str).replace(/,/g/"");
    while(num !== (num =num.replace(/^(-?\d+)(\d{3})/,"$1,$2")));
    return num;
};
